/* Initialization code */
const Ci = Components.interfaces;
const Cc = Components.classes;
var ThumbView = null;
var BookmarksPreviewUtils = {
  utils : null,
  displayRoot : null,
  location : null,
  contentDeck : null,
  selected : null,
  dir : null,
  bkmksTree : null,
  placesTree : null,
  _history : [],
  _historyIndex : 0,
  init : function(){
    try{
    dump("init\n");
    var self = BookmarksPreviewUtils;
    BookmarksPreviewUtils.dir = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
    BookmarksPreviewUtils.dir.append("bookmarkPreviews");
    if (!BookmarksPreviewUtils.dir.exists())
      BookmarksPreviewUtils.dir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0777);

    self.placesTree = document.getElementById("bookmark-folders-view");
    var folderWidth = self.placesTree.getAttribute("width");
    dump("folderWidth: "+folderWidth+"\n");
    dump("actual: "+self.placesTree.boxObject.width+"|"+self.placesTree.nextSibling.boxObject.x+"\n");
    /* since some lovely person decided, 'Hey, we don't need to include ids
      in order to make it easier for extension developers to overlay the
      bookmarks manager' these elements need to be added & positioned with
      javascript. Yay! */
    var vbox = document.createElement("vbox");
    vbox.setAttribute("id","defaultView");
    self.bkmksTree = document.getElementById("bookmarks-view");
    var bkmksWidth = self.bkmksTree.boxObject.width;//document.documentElement.boxObject.width - self.placesTree.width;//self.bkmksTree.boxObject.width
    var container = document.getElementById("albumview-container");
    container = container.parentNode.removeChild(container);
    vbox.appendChild(container);
    var splitter = document.createElement("splitter");
    var grippy = document.createElement("grippy");
    splitter.appendChild(grippy);
    splitter.setAttribute("id","albumview-splitter");
    splitter.setAttribute("oncommand","BookmarksPreviewUtils.onResize(event);");
    vbox.appendChild(splitter);

    var deck = document.createElement("deck");
    deck.setAttribute("id","contentDeck");
    deck.setAttribute("persist","width");
    deck.setAttribute("flex","4");
    deck.appendChild(vbox);
    self.bkmksTree.parentNode.insertBefore(deck,self.bkmksTree);
    /* Since xbl kills babies(bug 50349) the destructor isn't called when this
      is removed, although the constructor is called when it is re-added. That
      means the transaction listener gets added twice. Not good.... So remove
      it before we remove the element.
    */
    var bkmkTxnSvc = Components.classes["@mozilla.org/bookmarks/transactionmanager;1"]
                                .getService(Components.interfaces.nsIBookmarkTransactionManager);
    bkmkTxnSvc.transactionManager.RemoveListener(self.bkmksTree.bookmarkTreeTransactionListener);
    self.bkmksTree.parentNode.removeChild(self.bkmksTree);
    vbox.appendChild(self.bkmksTree);

    self.bkmksTree.treeBuilder.addObserver(BookmarksPreviewUtils);
    //bmFolderView.treeBuilder.addObserver(BookmarksPreviewUtils);
    /* Listen to when ref changes instead of the left tree's select
      observer because we also want to be notified when a search has
      been performed
    */
    self.bkmksTree.addEventListener("DOMAttrModified",self.refModified,false);
    /* set the folder tree back to its original size. After we remove the bkmks tree
    (so we can insert it into the deck) the folders tree expands because its flex is 1.*/
    setTimeout(function(){
      //self.placesTree.setAttribute("width",folderWidth);
      //deck.setAttribute("width",bkmksWidth);
    },11);

    /* create new menu items in the view menu */
    var nextElement = curElement = document.getElementById("view-separator");
    var insertbefore = document.getElementById("fill-after-this-node");
    var viewMenu = insertbefore.parentNode;
    var addItems = true;
    while(addItems){
      nextElement = curElement.nextSibling;
      addItems = curElement.id!="thumbsSize";
      viewMenu.insertBefore(curElement,insertbefore);
      curElement = nextElement;
    }

    /* Insert thumnail view in the correct spot */
    //ThumbView = document.getElementById("thumbnailView");
    //ThumbView = ThumbView.parentNode.removeChild(ThumbView);
    ThumbView = document.createElement("thumbnailview");
    ThumbView.setAttribute("id","thumbnailView");
    ThumbView = deck.appendChild(ThumbView);
    dump("thumbview: "+ThumbView+"\n");

    splitter = document.getElementById("bookmark-views-splitter");
    splitter.setAttribute("oncommand","BookmarksPreviewUtils.onResize(event);");

    const kPrefSvcContractID = "@mozilla.org/preferences-service;1";
    const kPrefSvcIID = Components.interfaces.nsIPrefService;
    var prefSvc = Components.classes[kPrefSvcContractID].getService(kPrefSvcIID);
    var prefs = prefSvc.getBranch(null);
    const kPrefBranchInternalIID = Components.interfaces.nsIPrefBranch2;
    var bookmarksPrefsInternal = prefs.QueryInterface(kPrefBranchInternalIID);
    bookmarksPrefsInternal.addObserver(self.sortChangedObserver.domain,
                                       self.sortChangedObserver, false);

    BookmarksPreviewUtils.contentDeck = deck;
    var detailsMenu = document.getElementById("detailsViewMenu");
    if (detailsMenu.getAttribute("checked"))
      BookmarksPreviewUtils.onSelectView('details');
    else{
      var thumbsMenu = detailsMenu.nextSibling;
      if (!thumbsMenu.getAttribute("checked"))
        BookmarksPreviewUtils.onSelectView('details');
      else
        BookmarksPreviewUtils.onSelectView('thumbnails');
    }
    // Adding the transaction listener
    var bkmkTxnSvc = Components.classes["@mozilla.org/bookmarks/transactionmanager;1"]
                              .getService(Components.interfaces.nsIBookmarkTransactionManager);
    bkmkTxnSvc.transactionManager.AddListener(self);
    window.addEventListener("resize",self.onResize,false);
    }catch(e){Components.utils.reportError(e);}
  },
  uninit : function(){
    var self = BookmarksPreviewUtils;
    self.bkmksTree.treeBuilder.removeObserver(BookmarksPreviewUtils);
    self.bkmksTree.removeEventListener("DOMAttrModified",self.refModified,false);
    window.removeEventListener("resize",self.onResize,false);
    // Unhook the sort change observer
    const kPrefSvcContractID = "@mozilla.org/preferences-service;1";
    const kPrefSvcIID = Components.interfaces.nsIPrefService;
    var prefSvc = Components.classes[kPrefSvcContractID].getService(kPrefSvcIID);
    var prefs = prefSvc.getBranch(null);
    const kPrefBranchInternalIID = Components.interfaces.nsIPrefBranch2;
    var bookmarksPrefsInternal = prefs.QueryInterface(kPrefBranchInternalIID);
    bookmarksPrefsInternal.removeObserver(self.sortChangedObserver.domain,
                                          self.sortChangedObserver);
    var bkmkTxnSvc = Components.classes["@mozilla.org/bookmarks/transactionmanager;1"]
                              .getService(Components.interfaces.nsIBookmarkTransactionManager);
    bkmkTxnSvc.transactionManager.RemoveListener(self);
    if (ThumbView.initiated)
      ThumbView.uninit();
    if (AlbumView.initiated)
      AlbumView.uninit();
  },
  onResize : function(event){
    BookmarksPreviewUtils.utils.onResize(event);
  },
  refModified : function(event){
    if (event.attrName=="ref" && event.target == BookmarksPreviewUtils.bkmksTree
        && !BookmarksPreviewUtils.utils.updatedSelection){
      dump("ref modified\n");
      BookmarksPreviewUtils.utils.refreshDisplay();
    }
  },
  sortChangedObserver : {
    domain: "browser.bookmarks.sort",
    observe: function BMU_sortChangedObserver(aSubject, aTopic, aPrefName) {
      if (aTopic != "nsPref:changed") return;
      if (aPrefName.substr(0, this.domain.length) != this.domain) return;
      dump("sort changed\n");
      setTimeout(function(){
        /* this is called before the tree ends up getting sorted, which we need because
          we take the results directly from the tree's view. setTimeout fixes it.
        */
        BookmarksPreviewUtils.utils.refreshDisplay(true);//.refreshSort();
      },0);
    }
  },
  onSelectView : function(type,event){
    dump("type: "+type+"\n");
    var self = BookmarksPreviewUtils;
    self.selected = type;
    if (type=="details"){
      if (!event || self.contentDeck.selectedIndex!=0){
        self.contentDeck.selectedIndex=0;
        if (ThumbViewUtils.initiated){
          ThumbViewUtils.uninit();
          //var bkmkTxnSvc = Components.classes["@mozilla.org/bookmarks/transactionmanager;1"]
          //                          .getService(Components.interfaces.nsIBookmarkTransactionManager);
          //bkmkTxnSvc.transactionManager.AddListener(self.bkmksTree.bookmarkTreeTransactionListener);
        }
        AlbumViewUtils.initDisplay();
      }
    } else if (type=="thumbnails"){
      if (!event || self.contentDeck.selectedIndex!=1){
        self.contentDeck.selectedIndex=1;
        if (AlbumView.initiated){
          AlbumView.uninit();
          ThumbViewUtils.initDisplay();
        }
        else{/* first load, give time for the contents to get set up */
          setTimeout(function(){ThumbViewUtils.initDisplay();},0);
        }
      }
    }
  },
  getViewRoot : function(aCurIndex, aRootIndex){
    var root;
    var curIndex = BookmarksPreviewUtils.bkmksTree.currentIndex;
    var rootIndex = -1;
    if (curIndex>-1 && BookmarksPreviewUtils.bkmksTree.tree.view.isContainer(curIndex))
      rootIndex = curIndex;
    else if (curIndex>-1)
      rootIndex = BookmarksPreviewUtils.bkmksTree.tree.view.getParentIndex(curIndex);;
    if (rootIndex>-1)
      root = BookmarksPreviewUtils.bkmksTree.getRowResource(rootIndex);
    else{
      root = BookmarksPreviewUtils.bkmksTree.getRootResource();
    }
    if (BookmarksPreviewUtils.displayRoot != root){
      BookmarksPreviewUtils.addToBackHistory(root,"utils");
      BookmarksPreviewUtils.displayRoot = root;
    }
    if (aCurIndex)
      aCurIndex.value = curIndex;
    if (aRootIndex)
      aRootIndex.value = rootIndex;
    //dump("currentindex: "+curIndex+"|"+BookmarksPreviewUtils.bkmksTree.tree.currentIndex+"|"+BookmarksPreviewUtils.bkmksTree.tree.view.selection.currentIndex+"\n");
    dump("getviewroot: "+root.Value+"|"+rootIndex+"|"+curIndex+"\n");
    //dump("root resource: "+BookmarksPreviewUtils.bkmksTree.getRootResource().Value+"|"+RDF.GetResource(BookmarksPreviewUtils.bkmksTree.tree.ref).Value+"\n");
    //dump("name: "+BookmarksPreviewUtils.getResourceName(root)+"\n");
    return root;
  },
  getResourceName : function(resource){
    var nameProp = "http://home.netscape.com/NC-rdf#Name";
    var oldValue = BMDS.GetTarget(resource, RDF.GetResource(nameProp), true);
    if (oldValue)
      return oldValue.Value;
    else
      return null;
  },
  getBookmarkImages : function(bkmks,folder){
    if (!folder)
      folder = BookmarksPreviewUtils.getViewRoot();
    //dump("getBookmarkImages: "+folder.Value+"\n");
    var self = BookmarksPreviewUtils;
    var idx = self.bkmksTree.treeBuilder.getIndexOfResource(folder);
    var view = self.bkmksTree.tree.view;
    var urlCol = self.bkmksTree.tree.columns.getNamedColumn("URL");
    var nameCol = self.bkmksTree.tree.columns.getNamedColumn("Name");
    var isOpen = idx==-1 || view.isContainerOpen(idx);
    if (!isOpen) view.toggleOpenState(idx);
    var level = view.getLevel(idx+1), rowCount = view.rowCount;
    for (var i = idx+1; i<rowCount; i++){
      var rowLevel = view.getLevel(i);
      if (rowLevel==level){
        var resource = self.bkmksTree.getRowResource(i);
        if (resource instanceof Components.interfaces.nsIRDFResource){
          var aType = BookmarksUtils.resolveType(resource);
          if (aType!="BookmarkSeparator"){
            var url = null;
            if (!view.isContainer(i))
              url = view.getCellText(i,urlCol);
            var name = view.getCellText(i,nameCol);
            var image = BookmarksPreviewUtils._getResourceImage(aType,url);
            bkmks.push({image: image,
                        caption: name && name.length>0?name:url,
                        url: url,
                        node: resource});
          }
        }
      }
      else if (rowLevel<level){
        break;
      }
    }
    if (!isOpen) view.toggleOpenState(idx);
  },
  _getResourceImage : function(aType,aURL){
    var nopreview = "chrome://bookmarkpreviews/skin/nopreview.png";
    var folderImage = "chrome://bookmarkpreviews/skin/folder.png";
    if (aType == "Livemark" || aType == "Folder" || aType=="PersonalToolbarFolder"){
      return folderImage;
    }
    if (!aURL){dump("nopreview: "+aType+"\n"); return nopreview;}
    var file = BookmarksPreviewUtils.dir.clone();
    file.append(encodeURIComponent(aURL.toLowerCase())+".jpg");
    //dump("file: "+file.path+"\n");
    if (file.exists() && file.isFile()){
      var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
      var uri = ios.newFileURI(file);
      if (uri)
        return uri.spec;
    }
    return nopreview;
  },
  addToBackHistory : function(resource,from){
    if (!this._history.some(function(ele,idx){
          return ele.Value == resource.Value;
        })){
      dump("addtobackhistory: "+resource.Value+" from: "+from+"|"+this._historyIndex+"|"+this._history.length+"\n");
      //this._history.forEach(function(item,idx){
      //  dump(idx+") "+item.Value+"\n");
      //});
      this._history.splice(0,this._historyIndex==0?0:this._historyIndex,resource);
      this._historyIndex = 0;

      //dump("after insert\n");
      //this._history.forEach(function(item,idx){
      //  dump(idx+") "+item.Value+"\n");
      //});
    }
    this.updateNavigationStates();
  },
  back : function(event){
    //dump("back\n");
    this.navigateHistory(1);
  },
  forward : function(event){
    this.navigateHistory(-1);
  },
  navigateHistory : function(direction){
    var location = this.getViewRoot();
    this._historyIndex+=direction;
    var historyEntry = this._history[this._historyIndex];
    BookmarksPreviewUtils.utils.updatedSelection = true;
    //var parent = BMDS.getParent(resource);
    if (historyEntry.Value=="NC:BookmarksTopRoot"){
      this.bkmksTree.tree.ref=historyEntry.Value;
      this.bkmksTree.tree.view.selection.clearSelection();
      this.bkmksTree.tree.view.selection.currentIndex=-1;
    }
    else{
      this.placesTree.tree.view.selection.clearSelection();
      this.placesTree.selectResource(historyEntry);
      var parent = BMDS.getParent(historyEntry);
      this.bkmksTree.tree.ref=parent.Value;
      this.bkmksTree.tree.view.selection.clearSelection();
      this.bkmksTree.selectResource(historyEntry);
    }
    BookmarksPreviewUtils.utils.updatedSelection = false;
    this.placesTree.treeBoxObject.ensureRowIsVisible(
      this.placesTree.treeBuilder.getIndexOfResource(historyEntry));
    //dump("nav refresh display\n");
    BookmarksPreviewUtils.utils.refreshDisplay();
    //dump("back: "+historyEntry.Value+"|"+this._historyIndex+"\n");
    //this._history.forEach(function(item,idx){
    //  dump(idx+") "+item.Value+"\n");
    //});
    //dump("idx|length: "+this._historyIndex+"|"+this._history.length+"\n");
    this.updateNavigationStates();
  },
  updateNavigationStates : function(){
    var backbutton = document.getElementById("back-button");
    if (this._historyIndex==this._history.length-1 ){
      backbutton.setAttribute("disabled","true");
    }
    else
      backbutton.removeAttribute("disabled");
    var forwardbutton = document.getElementById("forward-button");
    if (this._historyIndex==0 ){
      forwardbutton.setAttribute("disabled","true");
    }
    else
      forwardbutton.removeAttribute("disabled");
  },
  canDrop : function(index, orientation){},
  onDrop : function(row, orientation){
    dump("ondrop observer\n");
  },
  onToggleOpenState  : function(index){
    //dump("toggleopenstate\n");
  },
  onCycleHeader : function(column){},
  onCycleCell : function(row, column){},
  onSelectionChanged : function(){
    //dump("selection changed - "+AlbumView.updatedSelection+" - \n");
    if (!BookmarksPreviewUtils.utils.updatedSelection)
      /*
      This listens to the detailed view and the folder view.
      Although the selection of the detailed view is updated in time when
      this is sent from the detailed view's tree, it isn't updated
      in time when it is sent from a selection change from the folder
      view so we need to use setTimeout. Why 5 milliseconds? because 5 is
      cooler than 0, that's why.
      */

      setTimeout(function(){
        dump("selection changed - tree observer\n");
        BookmarksPreviewUtils.utils.refreshDisplay();
      },5);
  },
  onPerformAction : function(action){},
  onPerformActionOnRow : function(action, row){},
  onPerformActionOnCell : function(action, row, column){},
  _lastTransactionItem : null,
  observeTransaction : function(aTxn, aDo){
    if (!aTxn) return;
    aTxn = aTxn.wrappedJSObject;
    dump("aTxn: "+aTxn+"\n");
    var item = aTxn.item;
    this._lastTransactionItem = item;

    if (this.utils.updatedSelection) return;

    var type = aTxn.type;
    var itemType = BookmarksUtils.resolveType(item);
    if (itemType != "BookmarkSeparator"){
      var parent = aTxn.parent;
      if (parent == this.displayRoot){
        this.utils.refreshDisplay(true);
      }
    }
  },
  /* Transaction Listener */
  willDo: function (aTxmgr, aTxn) {},
  didDo : function (aTxmgr, aTxn) {
    this.observeTransaction(aTxn, true);
  },
  willUndo: function (aTxmgr, aTxn) {},
  didUndo : function (aTxmgr, aTxn) {
    this.observeTransaction(aTxn, false);
  },
  willRedo: function (aTxmgr, aTxn) {},
  didRedo : function (aTxmgr, aTxn) {
    this.observeTransaction(aTxn, true);
  },
  didMerge       : function (aTxmgr, aTxn) {},
  didBeginBatch  : function (aTxmgr, aTxn) {},
  didEndBatch    : function (aTxmgr, aTxn) {
    this.observeTransaction(aTxn, this.mLastTxnWasDo);
  },
  willMerge      : function (aTxmgr, aTxn) {},
  willBeginBatch : function (aTxmgr, aTxn) {},
  willEndBatch   : function (aTxmgr, aTxn) {}
}
var AlbumViewUtils = {
  all : null,
  bkmksTree : null,
  tree : null,
  view : null,
  get bkmksTree(){
    return BookmarksPreviewUtils.bkmksTree;
  },
  get displayRoot(){
    return BookmarksPreviewUtils.displayRoot;
  },
  set displayRoot(val){
    BookmarksPreviewUtils.displayRoot = val;
  },
  initDisplay : function(){
    BookmarksPreviewUtils.utils = AlbumViewUtils;
    AlbumViewUtils.tree = BookmarksPreviewUtils.bkmksTree.tree;
    AlbumViewUtils.view = BookmarksPreviewUtils.bkmksTree.tree.view;
    AlbumView.init();
    setTimeout(AlbumViewUtils.refreshDisplay,0);
  },
  uninit : function(){

  },
  onResize : function(event){
    if (AlbumView.canRefresh)
      AlbumView.refresh();
  },
  refreshDisplay : function(aForceRefresh){
    try{
      dump("refresh album display\n");
    var curIndexObj = new Object(), rootIndexObj = new Object();
    var previousRoot = AlbumViewUtils.displayRoot;
    var root = BookmarksPreviewUtils.getViewRoot(curIndexObj, rootIndexObj);
    var curIndex = curIndexObj.value, rootIndex = rootIndexObj.value;
    if (aForceRefresh || root!=previousRoot){
      var bkmks=[]
      BookmarksPreviewUtils.getBookmarkImages(bkmks,root);
      AlbumView.createImages(bkmks);
      AlbumView.current = AlbumView.target = 0;
    }
    var nextTarget=AlbumViewUtils._getNextTarget(curIndex,rootIndex);
    //nextTarget = 0;
    AlbumView.keepFocus = false;
    AlbumView.refresh();
    if (!(curIndex>-1 && AlbumViewUtils.view.isSeparator(curIndex)))
      AlbumView.glideTo(nextTarget*-150,false);
    }catch(e){
      Components.utils.reportError("AUTILS: "+e);
    }
  },
  _getNextTarget : function(cIndex,rIndex){
    if (cIndex>rIndex+1){
      var max = AlbumViewUtils.view.rowCount, level = AlbumViewUtils.view.getLevel(cIndex);
      var nextTarget = 0;//rIndex==-1?-1:0;
      for (var i = rIndex+1;i<cIndex;i++){
        if (AlbumViewUtils.view.getLevel(i)==level &&
           !AlbumViewUtils.view.isSeparator(i))
          nextTarget++;
      }
      return nextTarget;
    }
    return 0;
  },
  selectIndex : function(resource){
    if (AlbumView.keepFocus){
      AlbumViewUtils.updatedSelection = true;
      AlbumViewUtils.view.selection.clearSelection();
      AlbumViewUtils.bkmksTree.selectResource(resource);
      AlbumViewUtils.bkmksTree.treeBoxObject.ensureRowIsVisible(
          AlbumViewUtils.bkmksTree.treeBuilder.getIndexOfResource(resource));
      AlbumViewUtils.updatedSelection = false;
      //setTimeout(function(){AlbumViewUtils.container.focus();},0);
    }
    AlbumView.keepFocus = true;
  },
  performAction : function(resource,event){
    dump("albumviewutils.performaction: "+resource+"|"+event);
    var aType = BookmarksUtils.resolveType(resource);
    if (aType == "Bookmark"){
      var target = BMDS.GetTarget(resource, RDF.GetResource("http://home.netscape.com/NC-rdf#URL"), true);
      target = target.QueryInterface(Components.interfaces.nsIRDFLiteral);
      if (target){
        var url = target.Value;
        openUILink(url,event);
      }
    }
    else if (aType == "Folder" || aType == "Livemark" || aType == "PersonalToolbarFolder"){
      this.updatedSelection = true;
      this.bkmksTree.tree.view.selection.clearSelection();
      this.updatedSelection = false;
      this.bkmksTree.selectResource(resource);
      var index = this.bkmksTree.treeBuilder.getIndexOfResource(resource);
      if (!this.bkmksTree.tree.view.isContainerOpen(index))
        this.bkmksTree.tree.view.toggleOpenState(index);
      //AlbumViewUtils.refreshDisplay();
    }
  }
}
var ThumbViewUtils = {
  displayRoot : null,
  displayView : null,
  view : null,
  initDisplay : function(){
    ThumbViewUtils.displayView = ThumbView;
    BookmarksPreviewUtils.utils = ThumbViewUtils;
    document.getElementById('thumbsSize').removeAttribute("disabled");
    //ThumbView.init();
    this.refreshDisplay(true);
  },
  uninit : function(){
    this.initiated = false;
    document.getElementById('thumbsSize').setAttribute("disabled","true");
  },
  onResize : function(event){
    ThumbView.onResize(event);
  },
  refreshDisplay : function(aForceRefresh){;
    var bkmks=[];
    dump("refresh thumb display\n");
    this.initiated = true;
    BookmarksPreviewUtils.getBookmarkImages(bkmks);
    ThumbView.load(bkmks);
  },
  back : function(){BookmarksPreviewUtils.back();},
  forward : function(){BookmarksPreviewUtils.forward();},
  getBookmarkImages : BookmarksPreviewUtils.getBookmarkImages,
  _getNextTarget : function(cIndex,rIndex){
    if (cIndex>rIndex+1){
      var max = ThumbViewUtils.view.rowCount, level = ThumbViewUtils.view.getLevel(cIndex);
      var nextTarget = 0;//rIndex==-1?-1:0;
      for (var i = rIndex+1;i<cIndex;i++){
        if (ThumbViewUtils.view.getLevel(i)==level &&
           !ThumbViewUtils.view.isSeparator(i))
          nextTarget++;
      }
      return nextTarget;
    }
    return 0;
  },
  selectItem : function(item, event){
    dump("thumbviewutils selectitem: "+item+"\n");
    //ThumbViewUtils.updatedSelection = true;
    //BookmarksPreviewUtils.bkmksTree.tree.view.selection.clearSelection();
    //BookmarksPreviewUtils.bkmksTree.selectResource(item.node);
    //ThumbViewUtils.updatedSelection = false;
    return;
    if (gEditItemOverlay.itemId != -1) {
       var focusedElement = document.commandDispatcher.focusedElement;
       if ((focusedElement instanceof HTMLInputElement ||
            focusedElement instanceof HTMLTextAreaElement) &&
           /^editBMPanel.*/.test(focusedElement.parentNode.parentNode.id))
         focusedElement.blur();
     }

     var detailsDeck = document.getElementById("detailsDeck");
     if (item) {
       detailsDeck.selectedIndex = 1;
         var selectedNode = item.node;
         if (selectedNode.itemId != -1) {
           if (PlacesOrganizer._paneDisabled) {
             PlacesOrganizer._setDetailsFieldsDisabledState(false);
             PlacesOrganizer._paneDisabled = false;
           }

           gEditItemOverlay.initPanel(selectedNode.itemId,
                                      { hiddenRows: ["folderPicker"] });

           PlacesOrganizer._detectAndSetDetailsPaneMinimalState(selectedNode);
           return;
         }
     }
     else {
       detailsDeck.selectedIndex = 0;
       var selectItemDesc = document.getElementById("selectItemDescription");
       var itemsCountLabel = document.getElementById("itemsCountText");
       var rowCount = ThumbView.bookmarks.length;
       if (rowCount == 0) {
         selectItemDesc.hidden = true;
         itemsCountLabel.value = PlacesUtils.getString("detailsPane.noItems");
       }
       else {
         selectItemDesc.hidden = false;
         if (rowCount == 1)
           itemsCountLabel.value = PlacesUtils.getString("detailsPane.oneItem");
         else {
           itemsCountLabel.value =
             PlacesUtils.getFormattedString("detailsPane.multipleItems",
                                            [rowCount]);
         }
       }
     }

     // Nothing to do if the pane was already disabled
     if (!PlacesOrganizer._paneDisabled) {
       gEditItemOverlay.uninitPanel();
       PlacesOrganizer._setDetailsFieldsDisabledState(true);
       PlacesOrganizer._paneDisabled = true;
     }
  },
  performAction : function(item, event){
    dump("thumbviewutils.performaction\n");
    var resource = item.node;
    var aType = BookmarksUtils.resolveType(resource);
    if (aType == "Bookmark"){
      var target = BMDS.GetTarget(resource, RDF.GetResource("http://home.netscape.com/NC-rdf#URL"), true);
      target = target.QueryInterface(Components.interfaces.nsIRDFLiteral);
      if (target){
        var url = target.Value;
        openUILink(url,event);
      }
    }
    else if (aType == "Folder" || aType == "Livemark" || aType == "PersonalToolbarFolder"){

      BookmarksPreviewUtils.bkmksTree.selectResource(resource);
    }
  },
  removeItem : function(item, event){
    var resource = item.node;
    var parent = BMDS.getParent(resource);
    var selection = BookmarksUtils.getSelectionFromResource(resource, parent);
    BookmarksCommand.deleteBookmark(selection);
    dump("remove item refresh display\n");
    ThumbViewUtils.refreshDisplay();
  },
  isSorted : function(){
    //TODO: implement!
    var sorted = BookmarksPreviewUtils.placesTree.getAttribute("sortActive");
    dump("sorted: "+sorted+"\n");
    return false;
  }
}
window.addEventListener('load',BookmarksPreviewUtils.init,false);
window.addEventListener('unload',BookmarksPreviewUtils.uninit,false);
